package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * Telephony settings.
 */
@ApiModel(description = "Telephony settings.")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class VoipDeviceOsgConfigurationOpenApiVo   {
  @JsonProperty("portSettings")
  @Valid
  private List<VoipDevicePortSettingOpenApiVo> portSettings = null;

  @JsonProperty("callBlockingEnable")
  private Boolean callBlockingEnable;

  @JsonProperty("callBlockingProfileId")
  private String callBlockingProfileId;

  @JsonProperty("callBlockingProfileName")
  private String callBlockingProfileName;

  @JsonProperty("viaIpv6")
  private Boolean viaIpv6;

  public VoipDeviceOsgConfigurationOpenApiVo portSettings(List<VoipDevicePortSettingOpenApiVo> portSettings) {
    this.portSettings = portSettings;
    return this;
  }

  public VoipDeviceOsgConfigurationOpenApiVo addPortSettingsItem(VoipDevicePortSettingOpenApiVo portSettingsItem) {
    if (this.portSettings == null) {
      this.portSettings = new ArrayList<>();
    }
    this.portSettings.add(portSettingsItem);
    return this;
  }

  /**
   * VOIP device port setting.
   * @return portSettings
  */
  @ApiModelProperty(value = "VOIP device port setting.")

  @Valid

  public List<VoipDevicePortSettingOpenApiVo> getPortSettings() {
    return portSettings;
  }

  public void setPortSettings(List<VoipDevicePortSettingOpenApiVo> portSettings) {
    this.portSettings = portSettings;
  }

  public VoipDeviceOsgConfigurationOpenApiVo callBlockingEnable(Boolean callBlockingEnable) {
    this.callBlockingEnable = callBlockingEnable;
    return this;
  }

  /**
   * Whether to enable callBlocking.
   * @return callBlockingEnable
  */
  @ApiModelProperty(value = "Whether to enable callBlocking.")


  public Boolean getCallBlockingEnable() {
    return callBlockingEnable;
  }

  public void setCallBlockingEnable(Boolean callBlockingEnable) {
    this.callBlockingEnable = callBlockingEnable;
  }

  public VoipDeviceOsgConfigurationOpenApiVo callBlockingProfileId(String callBlockingProfileId) {
    this.callBlockingProfileId = callBlockingProfileId;
    return this;
  }

  /**
   * The call blocking profile ID of voip device.When callBlockingEnable is true, it can not be null.
   * @return callBlockingProfileId
  */
  @ApiModelProperty(value = "The call blocking profile ID of voip device.When callBlockingEnable is true, it can not be null.")


  public String getCallBlockingProfileId() {
    return callBlockingProfileId;
  }

  public void setCallBlockingProfileId(String callBlockingProfileId) {
    this.callBlockingProfileId = callBlockingProfileId;
  }

  public VoipDeviceOsgConfigurationOpenApiVo callBlockingProfileName(String callBlockingProfileName) {
    this.callBlockingProfileName = callBlockingProfileName;
    return this;
  }

  /**
   * The call blocking profile name of voip device.
   * @return callBlockingProfileName
  */
  @ApiModelProperty(value = "The call blocking profile name of voip device.")


  public String getCallBlockingProfileName() {
    return callBlockingProfileName;
  }

  public void setCallBlockingProfileName(String callBlockingProfileName) {
    this.callBlockingProfileName = callBlockingProfileName;
  }

  public VoipDeviceOsgConfigurationOpenApiVo viaIpv6(Boolean viaIpv6) {
    this.viaIpv6 = viaIpv6;
    return this;
  }

  /**
   * Whether via IPv6.
   * @return viaIpv6
  */
  @ApiModelProperty(value = "Whether via IPv6.")


  public Boolean getViaIpv6() {
    return viaIpv6;
  }

  public void setViaIpv6(Boolean viaIpv6) {
    this.viaIpv6 = viaIpv6;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VoipDeviceOsgConfigurationOpenApiVo voipDeviceOsgConfigurationOpenApiVo = (VoipDeviceOsgConfigurationOpenApiVo) o;
    return Objects.equals(this.portSettings, voipDeviceOsgConfigurationOpenApiVo.portSettings) &&
        Objects.equals(this.callBlockingEnable, voipDeviceOsgConfigurationOpenApiVo.callBlockingEnable) &&
        Objects.equals(this.callBlockingProfileId, voipDeviceOsgConfigurationOpenApiVo.callBlockingProfileId) &&
        Objects.equals(this.callBlockingProfileName, voipDeviceOsgConfigurationOpenApiVo.callBlockingProfileName) &&
        Objects.equals(this.viaIpv6, voipDeviceOsgConfigurationOpenApiVo.viaIpv6);
  }

  @Override
  public int hashCode() {
    return Objects.hash(portSettings, callBlockingEnable, callBlockingProfileId, callBlockingProfileName, viaIpv6);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VoipDeviceOsgConfigurationOpenApiVo {\n");
    
    sb.append("    portSettings: ").append(toIndentedString(portSettings)).append("\n");
    sb.append("    callBlockingEnable: ").append(toIndentedString(callBlockingEnable)).append("\n");
    sb.append("    callBlockingProfileId: ").append(toIndentedString(callBlockingProfileId)).append("\n");
    sb.append("    callBlockingProfileName: ").append(toIndentedString(callBlockingProfileName)).append("\n");
    sb.append("    viaIpv6: ").append(toIndentedString(viaIpv6)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

